# GridTypeProvider

> _Since v0.1.0_

Provides application-wide type defaults for all descendant grids.

Wrap your application (or part of it) with this provider to make
type-level renderers and editors available to all TbwGrid components.

```ts
const GridTypeProvider: DefineComponent<ExtractPropTypes<{ defaults: { type: PropType<TypeDefaultsMap>; required: true } }>, () => VNode<RendererNode, RendererElement, object>[] | undefined, object, object, object, ComponentOptionsMixin, ComponentOptionsMixin, object, string, PublicProps, ToResolvedProps<ExtractPropTypes<{ defaults: { type: PropType<TypeDefaultsMap>; required: true } }>, object>, object, object, object, object, string, ComponentProvideOptions, true, object, any>
```

#### Example

```vue
<script setup>
import { GridTypeProvider, type TypeDefaultsMap } from '@toolbox-web/grid-vue';
import { h } from 'vue';
import CountryBadge from './CountryBadge.vue';

const typeDefaults: TypeDefaultsMap = {
  country: {
    renderer: (ctx) => h(CountryBadge, { code: ctx.value }),
  },
};
</script>

<template>
  <GridTypeProvider :defaults="typeDefaults">
    <App />
  </GridTypeProvider>
</template>
```


# GridTypeProvider

Provides application-wide type defaults for all descendant grids.

Wrap your application (or part of it) with this provider to make
type-level renderers and editors available to all DataGrid components.

```ts
const GridTypeProvider: FC<GridTypeProviderProps>
```

#### Example

```tsx
// App.tsx or main.tsx
import { GridTypeProvider, type TypeDefaultsMap } from '@toolbox-web/grid-react';

const typeDefaults: TypeDefaultsMap = {
  country: {
    renderer: (ctx) => <CountryBadge code={ctx.value} />,
    editor: (ctx) => (
      <CountrySelect
        value={ctx.value}
        onSelect={(v) => ctx.commit(v)}
      />
    )
  },
  date: {
    renderer: (ctx) => formatDate(ctx.value),
    editor: (ctx) => <DatePicker value={ctx.value} onCommit={ctx.commit} />
  }
};

function App() {
  return (
    <GridTypeProvider defaults={typeDefaults}>
      <Dashboard />
    </GridTypeProvider>
  );
}
```

Any DataGrid with columns using `type: 'country'` will automatically
use the registered renderer/editor.
